# topicmaster.tcl v1.1 by domsen <domsen@domsen.org> (c)2oo1
#
# comments? bugs? ideas? plz mail me :)
#
# topicmaster is an advanced topic management tcl including the following
# functions:
# 
# -if the topic gets empty due to netsplit the last topic will be set again
# -returns infos about the currently set topic: nickname, host, date, time and so on
# -saves every topic to a historyfile except the ones set by the bot or the server
# -sets random topics from the historyfiles
# -possibility to recieve the historyfile via dcc
# -possibility to get a short topichistory
# -possibility to get the last topic number x
# -possibility for voiced and oped users to set a topic with a pub/msg command
# -advanced htmloutput including 7 different styles
# -badwordcheck with different revengemodes and flagcheck
# -owners can reset the historyfiles
# -statistics
# -all commands available via msg and pub
# -different settings for each chan
# -online help
#
# history:
# v1.1   - advanced html output with differen beautiful(?) styles addet
#          i like the styles of mirkstats very much so i decided to do
#          it the same way
#        - badwordcheck with different revengemodes and flagcheck
#        - possibility for voiced and oped users to set a topic with a pub/msg command
#        - bugfixes...
# v1.08  - problems with lasttopic/topichistory and spaces
#          in the historyfile fixed, thx to dirk
#        - voice and op users can set topics through .settopic
#        - added stats support. i had to change the structure of
#          the historyfile, so youre old historyfile is no longer
#          100% compatibel to this version
#        - small bugfixes
# v1.07g - unmatched open quote bug fixed
# v1.07f - basic html output, extra space bug fixed
# v1.05  - topiccounter added
# v1.0   - 1st final version
#
# config ######################################################################################

# triggers
set settopictrigger ".settopic"
set topictrigger ".topic"
set topichistory ".topichistory"
set lasttopics ".lasttopic"
set erasehistory "erasehistory"
set randomt ".random"
set gethistory ".gethistory"
set topicstats ".topicstats"
set topichelp ".topichelp"

# how many topics should the topichistory command send to the user?
set historylength "5"
# should voiced and oped users be allowed to set a topic with the .settopic command? (yes/no)
set settopic "yes"
# the chans the tcl is active in, "" for all or a list like "#chan1 #chan2"
set topicchans ""

# should the tcl make webpages? (yes/no)
set htmloutput "yes"
# the channels the tcl will create htmls for, "" for all or a list like "#chan1 #chan2"
# note: these must be also topicchans
set htmlchans ""
# your public html dir, thats where the history-htmlfiles will be stored
set pubhtmldir "/home/domsen/public_html/"
# which style should the tcl use? (see examplefiles)
# 1 -> chanex1.html
# 2 -> chanex2.html
# 3 -> chanex3.html
# 4 -> chanex4.html
# 5 -> chanex5.html
# 6 -> chanex6.html
# 7 -> chanex7.html
set htmlstyle "4"
# the maximum topics listed in the history-htmlfiles, "" for all
# note: a ~600topics logfile is ~400kb of size
set htmltopics ""

# enable badwordcheck? (yes/no)
set enablebadwords "yes"
# the words the tcl reponds to. sth like "france shit bitch"
set topicbadwords ""
# the flag the user must at least have to set a topic even if it has a bad word in it
set badwordexclude o
# revenge for setting a topic cotaining a bad word
# 0 -> none
# 1 -> msg
# 2 -> deop
# 3 -> kick
# 4 -> chattr -fhjmnoptx
# 5 -> chattr +dk
set revengemode 1


# dont change anything below ##################################################################

bind topc - * savetopic
bind topc - * topicleer
bind pub - $topictrigger pub_topic
bind msg - $topictrigger msg_topic

bind msg - $topichistory msg_history
bind pub - $topichistory pub_history

bind msg - $lasttopics msg_lasttopics
bind pub - $lasttopics pub_lasttopics

bind dcc n $erasehistory msg_erasehistory

bind pub - $randomt pub_randomtopic
bind msg - $randomt msg_randomtopic

bind pub - $gethistory pub_gethistory
bind msg - $gethistory msg_gethistory

bind msg - $topichelp msg_topichelp
bind pub - $topichelp pub_topichelp

bind pub - $settopictrigger pub_settopic
bind msg - $settopictrigger msg_settopic

bind pub - $topicstats pub_topicstats
bind msg - $topicstats msg_topicstats

set topicversion "v1.1"

proc msg_topichelp {nick uhost hand arg} {
global topicversion topictrigger topichistory lasttopics erasehistory randomt gethistory topichelp settopictrigger topicstats
putserv "privmsg $nick :topicmaster $topicversion by domsen <domsen@domsen.org>"
putserv "privmsg $nick :-"
putserv "privmsg $nick :the following pub commands are available:"
putserv "privmsg $nick :$topictrigger <?channel?> :returns infos about the topic"
putserv "privmsg $nick :$topichistory <?channel?> :returns the last 3 topics" 
putserv "privmsg $nick :$lasttopics <number> :returns the last topic number <number>"
putserv "privmsg $nick :$randomt <?channel?> :sets a random old topic"
putserv "privmsg $nick :$gethistory <?channel?> :sends the channels historyfile"
putserv "privmsg $nick :$settopictrigger <topic> :voiced and oped users can set a topic this way"
putserv "privmsg $nick :$topicstats <?channel?> :returns some statistics"
putserv "privmsg $nick :$topichelp :shows this help"
putserv "privmsg $nick :-"
putserv "privmsg $nick :the following msg commands are available:"
putserv "privmsg $nick :$topictrigger <channel> :returns infos about the topic"
putserv "privmsg $nick :$topichistory <channel> :returns the last 3 topics" 
putserv "privmsg $nick :$lasttopics <channel> <number> :returns the last topic number <number>"
putserv "privmsg $nick :$randomt <channel> :sets a random old topic"
putserv "privmsg $nick :$gethistory <channel> :sends the channels historyfile"
putserv "privmsg $nick :$settopictrigger <topic> :voiced and oped users can set a topic this way"
putserv "privmsg $nick :$topicstats <channel> :returns some statistics"
putserv "privmsg $nick :$topichelp :shows this help"
putserv "privmsg $nick :-"
putserv "privmsg $nick :the following pub commands are available:"
putserv "privmsg $nick :$erasehistory <channel> :deletes the history file (owners only)"
}

proc pub_topichelp {nick uhost hand chan arg} {
global topicversion topictrigger topichistory lasttopics erasehistory randomt gethistory topichelp topicchans settopictrigger
if {([lsearch -exact [string tolower $topicchans] [string tolower $chan]] != -1) || ($topicchans == "")} {
putserv "privmsg $nick :topicmaster $topicversion by domsen <domsen@domsen.org>"
putserv "privmsg $nick :-"
putserv "privmsg $nick :the following pub commands are available:"
putserv "privmsg $nick :$topictrigger <?channel?> :returns infos about the topic"
putserv "privmsg $nick :$topichistory <?channel?> :returns the last 3 topics" 
putserv "privmsg $nick :$lasttopics <number> :returns the last topic number <number>"
putserv "privmsg $nick :$randomt <?channel?> :sets a random old topic"
putserv "privmsg $nick :$gethistory <?channel?> :sends the channels historyfile"
putserv "privmsg $nick :$topichelp :shows this help"
putserv "privmsg $nick :-"
putserv "privmsg $nick :the following msg commands are available:"
putserv "privmsg $nick :$topictrigger <channel> :returns infos about the topic"
putserv "privmsg $nick :$topichistory <channel> :returns the last 3 topics" 
putserv "privmsg $nick :$lasttopics <channel> <number> :returns the last topic number <number>"
putserv "privmsg $nick :$randomt <channel> :sets a random old topic"
putserv "privmsg $nick :$gethistory <channel> :sends the channels historyfile"
putserv "privmsg $nick :$settopictrigger <topic> :voiced and oped users can set a topic this way"
putserv "privmsg $nick :$topichelp :shows this help"
putserv "privmsg $nick :-"
putserv "privmsg $nick :the following dcc commands are available:"
putserv "privmsg $nick :$erasehistory <channel> :deletes the history file (owners only)"
}}


proc msg_gethistory {nick uhost hand arg} {
global gethistory
if {$arg == ""} {
 putserv "privmsg $nick :usage: $gethistory <channel>"
 return 0}
if { $arg != ""} {
set historyfile "history.$args"
if {[file exists $historyfile]} {
switch -- [dccsend $historyfile $nick] {
0 { putserv "notice $nick :sending..." }
1 { putserv "notice $nick :error" }
2 { putserv "notice $nick :error" }
3 { putserv "notice $nick :error" }
4 { putserv "notice $nick :error" }
return 0
}}}}



proc pub_gethistory {nick uhost hand chan arg} {
global topicchans
if {([lsearch -exact [string tolower $topicchans] [string tolower $chan]] != -1) || ($topicchans == "")} {
if { $arg == ""} {set historyfile history.$chan }
if { $arg != ""} {set historyfile history.$arg }
if {[file exists $historyfile]} {
switch -- [dccsend $historyfile $nick] {
0 { putserv "notice $nick :sending..." }
1 { putserv "notice $nick :error" }
2 { putserv "notice $nick :error" }
3 { putserv "notice $nick :error" }
4 { putserv "notice $nick :error" }
return 0
}}}}

proc makeheader {channel style} {
global topicversion pubhtmldir
set htmlfile "$pubhtmldir$channel.html"
set dateichen [open $htmlfile w+]
puts $dateichen {<html><head>}
puts $dateichen "<title> $channel topichistory</title>"
if {$style == 1} {
puts $dateichen {<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"></head><body bgcolor="#E0E0F0" text="#000000"><table width="100%" border="0"><tr><td>}
puts $dateichen {<div align="center"><h3><font face="Arial, Helvetica, sans-serif">}
puts $dateichen "the #$channel topichistory"
puts $dateichen {</font></h3><p><font face="Arial, Helvetica, sans-serif" size="2">}
puts $dateichen "created by topicmaster.tcl $topicversion by domsen &lt;domsen@domsen.org&gt;</font></p>"
puts $dateichen {<div align="center"><table width="750" border="0" cellpadding="1" cellspacing="1"><tr><td width="4%" bgcolor="#A07088" height="17"><div align="center"><b>nr</b></div></td>}
puts $dateichen {<td width="18%" bgcolor="#70A098" height="17"><div align="center"><font size="2" face="Arial, Helvetica, sans-serif"><b>date set</b></font></div></td>}
puts $dateichen {<td width="65%" bgcolor="#7080B8" height="17"><div align="center"><font size="2" face="Arial, Helvetica, sans-serif"><b>topic</b></font></div></td>}
puts $dateichen {<td width="13%" bgcolor="#70A098" height="17"><div align="center"><font size="2" face="Arial, Helvetica, sans-serif"><b>set by</b></font></div></td></tr>}
} elseif { $style == 2 } {
puts $dateichen {<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"></head><body bgcolor="#000000" text="#E01400"><table width="100%" border="0"><tr><td>}
puts $dateichen {<div align="center"><h3><font face="Arial, Helvetica, sans-serif">}
puts $dateichen "the #$channel topichistory"
puts $dateichen {</font></h3><p><font face="Arial, Helvetica, sans-serif" size="2">}
puts $dateichen "created by topicmaster.tcl $topicversion by domsen &lt;domsen@domsen.org&gt;</font></p>"
puts $dateichen {<div align="center"><table width="750" border="0" cellpadding="1" cellspacing="1"><tr><td width="4%" bgcolor="#484850" height="17"><font size="2" face="Arial, Helvetica, sans-serif" color="#E8ECE8"><div align="center" ><b>nr</b></div></td>}
puts $dateichen {<td width="18%" bgcolor="#506858" height="17"><div align="center"><font size="2" face="Arial, Helvetica, sans-serif" color="#E8ECE8"><b>date set</b></font></div></td>}
puts $dateichen {<td width="65%" bgcolor="#583C40" height="17"><div align="center"><font size="2" face="Arial, Helvetica, sans-serif" color="#E8ECE8"><b>topic</b></font></div></td>}
puts $dateichen {<td width="13%" bgcolor="#506858" height="17"><div align="center"><font size="2" face="Arial, Helvetica, sans-serif" color="#E8ECE8"><b>set by</b></font></div></td></tr>}
} elseif { $style == 3 } {
puts $dateichen {<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"></head><body bgcolor="#FFFFFF" text="#000000"><table width="100%" border="0"><tr><td>}
puts $dateichen {<div align="center"><h3><font face="Arial, Helvetica, sans-serif">}
puts $dateichen "the #$channel topichistory"
puts $dateichen {</font></h3><p><font face="Arial, Helvetica, sans-serif" size="2">}
puts $dateichen "created by topicmaster.tcl $topicversion by domsen &lt;domsen@domsen.org&gt;</font></p>"
puts $dateichen {<div align="center"><table width="750" border="0" cellpadding="1" cellspacing="1"><tr><td width="4%" bgcolor="#88C470" height="17"><div align="center"><b>nr</b></div></td>}
puts $dateichen {<td width="18%" bgcolor="#88C470" height="17"><div align="center"><font size="2" face="Arial, Helvetica, sans-serif"><b>date set</b></font></div></td>}
puts $dateichen {<td width="65%" bgcolor="#78B858" height="17"><div align="center"><font size="2" face="Arial, Helvetica, sans-serif"><b>topic</b></font></div></td>}
puts $dateichen {<td width="13%" bgcolor="#70A450" height="17"><div align="center"><font size="2" face="Arial, Helvetica, sans-serif"><b>set by</b></font></div></td></tr>}
} elseif { $style == 4 } {
puts $dateichen {<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"></head><body bgcolor="#000000" text="#000000"><table width="100%" border="0"><tr><td>}
puts $dateichen {<div align="center"><h3><font face="Arial, Helvetica, sans-serif" color="#E0DCB8">}
puts $dateichen "the #$channel topichistory"
puts $dateichen {</font></h3><p><font face="Arial, Helvetica, sans-serif" size="2" color="#E0DCB8">}
puts $dateichen "created by topicmaster.tcl $topicversion by domsen &lt;domsen@domsen.org&gt;</font></p>"
puts $dateichen {<div align="center"><table width="750" border="0" cellpadding="1" cellspacing="1"><tr><td width="4%" bgcolor="#B4B1A5" height="17"><div align="center"><b>nr</b></div></td>}
puts $dateichen {<td width="18%" bgcolor="#90A068" height="17"><div align="center"><font size="2" face="Arial, Helvetica, sans-serif"><b>date set</b></font></div></td>}
puts $dateichen {<td width="65%" bgcolor="#708C68" height="17"><div align="center"><font size="2" face="Arial, Helvetica, sans-serif"><b>topic</b></font></div></td>}
puts $dateichen {<td width="13%" bgcolor="#A87C48" height="17"><div align="center"><font size="2" face="Arial, Helvetica, sans-serif"><b>set by</b></font></div></td></tr>}
} elseif { $style == 5 } {
puts $dateichen {<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"></head><body bgcolor="#002820" text="#000000"><table width="100%" border="0"><tr><td>}
puts $dateichen {<div align="center"><h3><font face="Arial, Helvetica, sans-serif" color="#F8FCD0">}
puts $dateichen "the #$channel topichistory"
puts $dateichen {</font></h3><p><font face="Arial, Helvetica, sans-serif" size="2" color="#F8FCD0">}
puts $dateichen "created by topicmaster.tcl $topicversion by domsen &lt;domsen@domsen.org&gt;</font></p>"
puts $dateichen {<div align="center"><table width="750" border="0" cellpadding="1" cellspacing="1"><tr><td width="4%" bgcolor="#ACD7AC" height="17"><div align="center"><b>nr</b></div></td>}
puts $dateichen {<td width="18%" bgcolor="#C8C8D2" height="17"><div align="center"><font size="2" face="Arial, Helvetica, sans-serif"><b>date set</b></font></div></td>}
puts $dateichen {<td width="65%" bgcolor="#C8C8DC" height="17"><div align="center"><font size="2" face="Arial, Helvetica, sans-serif"><b>topic</b></font></div></td>}
puts $dateichen {<td width="13%" bgcolor="#C8C8E6" height="17"><div align="center"><font size="2" face="Arial, Helvetica, sans-serif"><b>set by</b></font></div></td></tr>}
} elseif { $style == 6 } {
puts $dateichen {<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"></head><body bgcolor="#FFFFF8" text="#000000"><table width="100%" border="0"><tr><td>}
puts $dateichen {<div align="center"><h3><font face="Arial, Helvetica, sans-serif" color="#2890FF">}
puts $dateichen "the #$channel topichistory"
puts $dateichen {</font></h3><p><font face="Arial, Helvetica, sans-serif" size="2" color="#2890FF">}
puts $dateichen "created by topicmaster.tcl $topicversion by domsen &lt;domsen@domsen.org&gt;</font></p>"
puts $dateichen {<div align="center"><table width="750" border="0" cellpadding="1" cellspacing="1"><tr><td width="4%" bgcolor="#FF0000" height="17"><div align="center"><b>nr</b></div></td>}
puts $dateichen {<td width="18%" bgcolor="#FF7800" height="17"><div align="center"><font size="2" face="Arial, Helvetica, sans-serif"><b>date set</b></font></div></td>}
puts $dateichen {<td width="65%" bgcolor="#FFB410" height="17"><div align="center"><font size="2" face="Arial, Helvetica, sans-serif"><b>topic</b></font></div></td>}
puts $dateichen {<td width="13%" bgcolor="#FFF000" height="17"><div align="center"><font size="2" face="Arial, Helvetica, sans-serif"><b>set by</b></font></div></td></tr>}
} elseif { $style == 7 } {
puts $dateichen {<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"></head><body bgcolor="#000000" text="#000000"><table width="100%" border="0"><tr><td>}
puts $dateichen {<div align="center"><h3><font face="Arial, Helvetica, sans-serif" color="#CC0000">}
puts $dateichen "the #$channel topichistory"
puts $dateichen {</font></h3><p><font face="Arial, Helvetica, sans-serif" size="2" color="#CC0000">}
puts $dateichen "created by topicmaster.tcl $topicversion by domsen &lt;domsen@domsen.org&gt;</font></p>"
puts $dateichen {<div align="center"><table width="750" border="0" cellpadding="1" cellspacing="1"><tr><td width="4%" bgcolor="#3300ff" height="17"><div align="center"><b>nr</b></div></td>}
puts $dateichen {<td width="18%" bgcolor="#3333FF" height="17"><div align="center"><font size="2" face="Arial, Helvetica, sans-serif"><b>date set</b></font></div></td>}
puts $dateichen {<td width="65%" bgcolor="#3366FF" height="17"><div align="center"><font size="2" face="Arial, Helvetica, sans-serif"><b>topic</b></font></div></td>}
puts $dateichen {<td width="13%" bgcolor="#3399FF" height="17"><div align="center"><font size="2" face="Arial, Helvetica, sans-serif"><b>set by</b></font></div></td></tr>}
} else {
putlog "topicmaster: stlye number $style not found, aborting"
return 0 }
close $dateichen
}


proc makebottom {channel} {
global pubhtmldir
set htmlfile "$pubhtmldir$channel.html"
set dateichen [open $htmlfile a]
puts $dateichen {</table></div></td></tr></table></body></html>}
close $dateichen
}


proc dohtml {channel style} {
global pubhtmldir htmltopics
set channel2 $channel
set historyfile "history.$channel2"
if {[file exists $historyfile]} {
regsub -all "#" $channel "" channel
global pubhtmltdir
set topicnumber 0
file delete "$channel2.html"
makeheader $channel $style
set dateichen [open "$historyfile" r]
set htmlfile "$pubhtmldir$channel.html"
set dateichen2 [open $htmlfile a]
while {![eof $dateichen]} {
if {($htmltopics != "") && ( $topicnumber == $htmltopics) } {
close $dateichen
close $dateichen2
makebottom $channel
return 0
}



set zeile [gets $dateichen]
if {$zeile != ""} {
incr topicnumber
set zeile [split $zeile]
set nickname [lindex $zeile 0]
set weekday [lindex $zeile 3]
set month [lindex $zeile 4]
set day [lindex $zeile 5]
set daytime [lindex $zeile 6]
set year [lindex $zeile 7]
set topic [join [lrange $zeile 9 [llength $zeile]]]
if {($day == "" )} {
set day [lindex $zeile 6]
set daytime [lindex $zeile 7]
set year [lindex $zeile 8]
set topic [join [lrange $zeile 10 [llength $zeile]]]
}
if {$style == 1} {
puts $dateichen2 {<tr><td width="4%" height="18" bgcolor="#C090A8"><div align="right"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><div align="right">}
puts $dateichen2 "$topicnumber </font></div></td></div>"
puts $dateichen2 {<td width="18%" bgcolor="#90C0B8" height="18"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><div align="center">}
puts $dateichen2 "$daytime $day.$month.$year</font></div></td></div>"
puts $dateichen2 {<td width="65%" bgcolor="#90A0D8" height="18"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><div align="center">}
puts $dateichen2 "$topic</font></td></div>"
puts $dateichen2 {<td width="13%" bgcolor="#90C0B8" height="18"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><div align="center">}
puts $dateichen2 "$nickname</font></td></tr></div>"
} elseif { $style == 2 } {
puts $dateichen2 {<tr><td width="4%" height="18" bgcolor="#585C68"><div align="right"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#E8ECE8"><div align="right">}
puts $dateichen2 "$topicnumber </font></div></td></div>"
puts $dateichen2 {<td width="18%" bgcolor="#708070" height="18"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#E8ECE8"><div align="center">}
puts $dateichen2 "$daytime $day.$month.$year</font></div></td></div>"
puts $dateichen2 {<td width="65%" bgcolor="#805C60" height="18"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#E8ECE8"><div align="center">}
puts $dateichen2 "$topic</font></td></div>"
puts $dateichen2 {<td width="13%" bgcolor="#708070" height="18"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#E8ECE8"><div align="center">}
puts $dateichen2 "$nickname</font></td></tr></div>"
} elseif { $style == 3 } {
puts $dateichen2 {<tr><td width="4%" height="18" bgcolor="#007C00"><div align="right"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><div align="right">}
puts $dateichen2 "$topicnumber </font></div></td></div>"
puts $dateichen2 {<td width="18%" bgcolor="#B8B8F0" height="18"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><div align="center">}
puts $dateichen2 "$daytime $day.$month.$year</font></div></td></div>"
puts $dateichen2 {<td width="65%" bgcolor="#9090E0" height="18"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><div align="center">}
puts $dateichen2 "$topic</font></td></div>"
puts $dateichen2 {<td width="13%" bgcolor="#787CE0" height="18"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><div align="center">}
puts $dateichen2 "$nickname</font></td></tr></div>"
} elseif { $style == 4 } {
puts $dateichen2 {<tr><td width="4%" height="18" bgcolor="#908C78"><div align="right"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><div align="right">}
puts $dateichen2 "$topicnumber </font></div></td></div>"
puts $dateichen2 {<td width="18%" bgcolor="#808858" height="18"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><div align="center">}
puts $dateichen2 "$daytime $day.$month.$year</font></div></td></div>"
puts $dateichen2 {<td width="65%" bgcolor="#587458" height="18"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><div align="center">}
puts $dateichen2 "$topic</font></td></div>"
puts $dateichen2 {<td width="13%" bgcolor="#806438" height="18"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><div align="center">}
puts $dateichen2 "$nickname</font></td></tr></div>"
} elseif { $style == 5 } {
puts $dateichen2 {<tr><td width="4%" height="18" bgcolor="#D0E8D0"><div align="right"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><div align="right">}
puts $dateichen2 "$topicnumber </font></div></td></div>"
puts $dateichen2 {<td width="18%" bgcolor="#A0A0AA" height="18"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><div align="center">}
puts $dateichen2 "$daytime $day.$month.$year</font></div></td></div>"
puts $dateichen2 {<td width="65%" bgcolor="#A0A0B4" height="18"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><div align="center">}
puts $dateichen2 "$topic</font></td></div>"
puts $dateichen2 {<td width="13%" bgcolor="#A0A0BE" height="18"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><div align="center">}
puts $dateichen2 "$nickname</font></td></tr></div>"
} elseif { $style == 6 } {
puts $dateichen2 {<tr><td width="4%" height="18" bgcolor="#FF3C00"><div align="right"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><div align="right">}
puts $dateichen2 "$topicnumber </font></div></td></div>"
puts $dateichen2 {<td width="18%" bgcolor="#0080FF" height="18"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><div align="center">}
puts $dateichen2 "$daytime $day.$month.$year</font></div></td></div>"
puts $dateichen2 {<td width="65%" bgcolor="#00A0FF" height="18"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><div align="center">}
puts $dateichen2 "$topic</font></td></div>"
puts $dateichen2 {<td width="13%" bgcolor="#00C0FF" height="18"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><div align="center">}
puts $dateichen2 "$nickname</font></td></tr></div>"
} elseif { $style == 7 } {
puts $dateichen2 {<tr><td width="4%" height="18" bgcolor="#CC0000"><div align="right"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><div align="right">}
puts $dateichen2 "$topicnumber </font></div></td></div>"
puts $dateichen2 {<td width="18%" bgcolor="#FF3300" height="18"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><div align="center">}
puts $dateichen2 "$daytime $day.$month.$year</font></div></td></div>"
puts $dateichen2 {<td width="65%" bgcolor="#FF6600" height="18"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><div align="center">}
puts $dateichen2 "$topic</font></td></div>"
puts $dateichen2 {<td width="13%" bgcolor="#FF9900" height="18"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><div align="center">}
puts $dateichen2 "$nickname</font></td></tr></div>"
}
}}
close $dateichen
close $dateichen2
makebottom $channel
}} 


proc countlines {arg} {
set counter 0
set channel [lindex $arg 0]
set historyfile "history.$channel"
if {[file exists $historyfile]} {
set dateichen [open "$historyfile" r]
while {![eof $dateichen]} {
set line [gets $dateichen]
if {($line != "") && ($line != " ")} {
incr counter }}
close $dateichen
return $counter } else { return 0 }
}


proc msg_topicstats {nick uhost hand arg} {
global topicversion topicchans
set gtopics 0
set noc [llength $topicchans]
if {$noc == 0} { set noc "all" }
set allchans [llength [channels]]
if {$arg == ""} {
if {$topicchans == "" } {
foreach chan [channels] { set gtopics [expr $gtopics + [countlines $chan]]
}} else {
foreach chan $topicchans { set gtopics [expr $gtopics + [countlines $chan]] }
}
putserv "privmsg $nick :Topicmaster $topicversion is running in $noc of my $allchans channels and i've recorded $gtopics topics."
}
if {$arg != ""} {
if {$topicchans == "" } {
if {[string first $arg [channels] ] == -1 } {
putserv "privmsg $nick :i'm not monitoring this channel"
return 0 }
foreach chan [channels] { set gtopics [expr $gtopics + [countlines $chan]]
}} else {
if {[string first $arg $topicchans ] == -1 } {
putserv "privmsg $nick :i'm not monitoring this channel"
return 0 }
foreach chan $topicchans { set gtopics [expr $gtopics + [countlines $chan]] }
}
putserv "privmsg $nick :Topicmaster $topicversion is running in $noc of my $allchans channels and i've recorded [countlines $arg] of my total $gtopics topics in $arg."
}}


proc pub_topicstats {nick uhost hand chan arg} {
global topicchans topicversion
set gtopics 0
set noc [llength $topicchans]
if {$noc == 0} { set noc "all" }
set allchans [llength [channels]]
if {$arg == ""} {
if {$topicchans == "" } {
foreach tchan [channels] { set gtopics [expr $gtopics + [countlines $tchan]] }
putserv "notice $nick :Topicmaster $topicversion is running in $noc of my $allchans channels and i've recorded [countlines $chan] of my total $gtopics topics in $chan."
}
if {$topicchans != ""  } {
if {[string first $chan $topicchans ] == -1 } {
foreach tchan [channels] { set gtopics [expr $gtopics + [countlines $tchan]] }
putserv "notice $nick :Topicmaster $topicversion is running in $noc of my $allchans channels and i've recorded $gtopics topics."
}
if {[string first $chan $topicchans ] != -1 } {
foreach tchan [channels] { set gtopics [expr $gtopics + [countlines $tchan]] }
putserv "notice $nick :Topicmaster $topicversion is running in $noc of my $allchans channels and i've recorded [countlines $chan] of my total $gtopics topics in $chan."
}}}
if {$arg != ""} {
if {$topicchans == "" } {
foreach tchan [channels] { set gtopics [expr $gtopics + [countlines $tchan]] }
putserv "notice $nick :Topicmaster $topicversion is running in $noc of my $allchans channels and i've recorded [countlines $arg] of my total $gtopics topics in $arg."
}
if {$topicchans != ""  } {
if {[string first $arg $topicchans ] == -1 } {
foreach tchan [channels] { set gtopics [expr $gtopics + [countlines $tchan]] }
putserv "notice $nick :Topicmaster $topicversion is running in $noc of my $allchans channels and i've recorded $gtopics topics."
}
if {[string first $arg $topicchans ] != -1 } {
foreach tchan [channels] { set gtopics [expr $gtopics + [countlines $tchan]] }
putserv "notice $nick :Topicmaster $topicversion is running in $noc of my $allchans channels and i've recorded [countlines $arg] of my total $gtopics topics in $arg."
}}}}



proc msg_randomtopic {nick uhost hand arg} {
global randomt topicchans
if {$arg == ""} {
 putserv "privmsg $nick :usage: $randomt <channel>"
 return 0}
if { $arg != ""} {
if {([lsearch [string tolower $topicchans] [string tolower $arg]] != -1) || ($topicchans == "")} {
set gesamtlines 0
set historyfile "history.$arg"
if {[file exists $historyfile]} {
set dateichen [open "$historyfile" r]
while {![eof $dateichen]} {
if {[gets $dateichen] != ""} {
incr gesamtlines }
}
close $dateichen
set nummer [rand $gesamtlines]
set counter 0
set dateichen2 [open "$historyfile" r]
while {![eof $dateichen2]} {
set zeile [gets $dateichen2]
if {$counter == $nummer} {
set zeile [split $zeile]
set nickname [lindex $zeile 0]
set channel [lindex $zeile 1]
set hostmask [lindex $zeile 2]
set weekday [lindex $zeile 3]
set month [lindex $zeile 4]
set day [lindex $zeile 5]
set daytime [lindex $zeile 6]
set year [lindex $zeile 7]
set topic [join [lrange $zeile 9 [llength $zeile]]]
if {($day == "" )} {
set day [lindex $zeile 6]
set daytime [lindex $zeile 7]
set year [lindex $zeile 8]
set topic [join [lrange $zeile 10 [llength $zeile]]]
}
putserv "topic $arg :$topic"
putserv "notice $nick :($counter/$gesamtlines) set by $nickname ($hostmask) $daytime $weekday $day $month $year"}
incr counter}
close $dateichen2
}}}}


proc pub_randomtopic {nick uhost hand chan arg} {
global topicchans
if {([lsearch -exact [string tolower $topicchans] [string tolower $chan]] != -1) || ($topicchans == "")} {
if { $arg == ""} {set historyfile history.$chan
set channel $chan }
if { $arg != ""} {set historyfile history.$arg
set channel $arg }
set gesamtlines 0
if {[file exists $historyfile]} {
set dateichen [open "$historyfile" r]
while {![eof $dateichen]} {
if {[gets $dateichen] != ""} {
incr gesamtlines }
}
close $dateichen
set nummer [rand $gesamtlines]
set counter 0
set dateichen2 [open "$historyfile" r]
while {![eof $dateichen2]} {
set zeile [gets $dateichen2]
if {$counter == $nummer} {
set zeile [split $zeile]
set nickname [lindex $zeile 0]
set channel [lindex $zeile 1]
set hostmask [lindex $zeile 2]
set weekday [lindex $zeile 3]
set month [lindex $zeile 4]
set day [lindex $zeile 5]
set daytime [lindex $zeile 6]
set year [lindex $zeile 7]
set topic [join [lrange $zeile 9 [llength $zeile]]]
if {($day == "" )} {
set day [lindex $zeile 6]
set daytime [lindex $zeile 7]
set year [lindex $zeile 8]
set topic [join [lrange $zeile 10 [llength $zeile]]]
}
putserv "topic $channel :$topic"
putserv "notice $nick :topic ($counter/$gesamtlines) set by $nickname ($hostmask) $daytime $weekday $day $month $year"}
incr counter}
close $dateichen2
}}}




proc msg_erasehistory {hand idx arg} {
global erasehistory
if {$arg == ""} {
putdcc $idx "usage: $erasehistory <channel>"
 return 0}
if {$arg != ""} {
set historyfile "history.$arg"
if {[file exists $historyfile]} {
set olerocks [countlines $arg]
file delete "$historyfile"
putdcc $idx "$historyfile deleted, $olerocks topic(s) lost"
}}}


proc msg_lasttopics {nick uhost hand arg} {
global lasttopics
if {$arg == ""} {
 putserv "privmsg $nick :usage: $lasttopics <channel> <topicnumber>"
 return 0}
if { $arg != ""} {
set channel [lindex $arg 0]
set pointer [lindex $arg 1]
set counter "1"
if {$pointer > "0"} {
set historyfile "history.$channel"
if {[file exists $historyfile]} {
set dateichen [open "$historyfile" r]
while {![eof $dateichen]} {
set zeile [gets $dateichen]
if {$counter == $pointer} {
set zeile [split $zeile]
set nickname [lindex $zeile 0]
set channel [lindex $zeile 1]
set hostmask [lindex $zeile 2]
set weekday [lindex $zeile 3]
set month [lindex $zeile 4]
set day [lindex $zeile 5]
set daytime [lindex $zeile 6]
set year [lindex $zeile 7]set handle [lindex $zeile 8]
set topic [join [lrange $zeile 9 [llength $zeile]]]
if {($day == "" )} {
set day [lindex $zeile 6]
set daytime [lindex $zeile 7]
set year [lindex $zeile 8]
set topic [join [lrange $zeile 10 [llength $zeile]]]
}
set olerocks [countlines $channel]
putserv "privmsg $nick :last topic number $pointer of $olerocks: '$topic' was set by $nickname ($hostmask) at $daytime $weekday $day $month $year"
return 0
}
incr counter
}}}}}

proc pub_lasttopics {nick uhost hand chan arg} {
global lasttopics topicchans
if {([lsearch -exact [string tolower $topicchans] [string tolower $chan]] != -1) || ($topicchans == "")} {
if {$arg == ""} {
 putserv "privmsg $nick :usage: $lasttopics <topicnumber>"
 return 0}
if { $arg != ""} {
set pointer [lindex $arg 0]
set counter "1"
if {$pointer > "0"} {
set historyfile "history.$chan"
if {[file exists $historyfile]} {
set dateichen [open "$historyfile" r]
while {![eof $dateichen]} {
set zeile [gets $dateichen]
if {$counter == $pointer} {
set zeile [split $zeile]
set nickname [lindex $zeile 0]
set channel [lindex $zeile 1]
set hostmask [lindex $zeile 2]
set weekday [lindex $zeile 3]
set month [lindex $zeile 4]
set day [lindex $zeile 5]
set daytime [lindex $zeile 6]
set year [lindex $zeile 7]
set topic [join [lrange $zeile 9 [llength $zeile]]]
if {($day == "" )} {
set day [lindex $zeile 6]
set daytime [lindex $zeile 7]
set year [lindex $zeile 8]
set topic [join [lrange $zeile 10 [llength $zeile]]]
}
set olerocks [countlines $chan]
putserv "notice $nick :last topic number $pointer of $olerocks: '$topic' was set by $nickname ($hostmask) at $daytime $weekday $day $month $year"
return 0
}
incr counter
}}}}}}



proc msg_history {nick uhost hand arg} {
global topichistory historylength
if {$arg == ""} {
 putserv "privmsg $nick :usage: $topichistory <channel>"
 return 0}
if { $arg != ""} {
set historyfile history.$arg
if {[file exists $historyfile]} { 
set dateichen [open "$historyfile" r]
set counter "0"
while {![eof $dateichen]} {
set zeile [gets $dateichen]
set zeile [split $zeile]
set nickname [lindex $zeile 0]
set channel [lindex $zeile 1]
set hostmask [lindex $zeile 2]
set weekday [lindex $zeile 3]
set month [lindex $zeile 4]
set day [lindex $zeile 5]
set daytime [lindex $zeile 6]
set year [lindex $zeile 7]
set topic [join [lrange $zeile 9 [llength $zeile]]]
if {($day == "" )} {
set day [lindex $zeile 6]
set daytime [lindex $zeile 7]
set year [lindex $zeile 8]
set topic [join [lrange $zeile 10 [llength $zeile]]]
}
if {($counter < $historylength) && ($topic != "") } {
set olerocks [countlines $arg]
putserv "privmsg $nick :($olerocks topics available) the topic '$topic' was set by $nickname ($hostmask) at $daytime $weekday $day $month $year"}
incr counter
}}
close $dateichen
}}



proc pub_history {nick uhost hand chan arg} {
global topicchans historylength
if {([lsearch -exact [string tolower $topicchans] [string tolower $chan]] != -1) || ($topicchans == "")} {
if { $arg == ""} {
set historyfile "history.$chan"
set kanal $chan
}
if { $arg != ""} {
set historyfile "history.$arg"
set kanal $arg }
if {[file exists $historyfile]} {
set dateichen [open "$historyfile" r]
set counter "0"
while {![eof $dateichen]} {
set zeile [gets $dateichen]
set zeile [split $zeile]
set nickname [lindex $zeile 0]
set channel [lindex $zeile 1]
set hostmask [lindex $zeile 2]
set weekday [lindex $zeile 3]
set month [lindex $zeile 4]
set day [lindex $zeile 5]
set daytime [lindex $zeile 6]
set year [lindex $zeile 7]
set topic [join [lrange $zeile 9 [llength $zeile]]]
if {($day == "" )} {
set day [lindex $zeile 6]
set daytime [lindex $zeile 7]
set year [lindex $zeile 8]
set topic [join [lrange $zeile 10 [llength $zeile]]]
}
if {($counter < $historylength) && ($topic != "")} {
set olerocks [countlines $kanal]
putserv "notice $nick :($olerocks topics available) the topic '$topic' was set by $nickname ($hostmask) at $daytime $weekday $day $month $year"}
incr counter
}}
close $dateichen
}}


proc savetopic {nick uhost hand chan topic} {
global topicchans htmlstyle htmlchans botnick htmloutput enablebadwords topicbadwords badwordexclude revengemode
if {([lsearch -exact [string tolower $topicchans] [string tolower $chan]] != -1) || ($topicchans == "")} {
set found 0
if {($enablebadwords == "yes") && ($nick != "*") && ($uhost != "*") && ($topic != "") && ($nick != $botnick) && ([matchattr $hand $badwordexclude] != 1) } {
foreach i [string tolower $topicbadwords] {
if {[string first $i [string tolower $topic]] != -1} { set found 1 }
}
if {$found == 1} {
if {$revengemode == 1} { putserv "notice $nick :please dont set topics containing bad words" }
if {$revengemode == 2} { putserv "mode $chan -o $nick" }
if {$revengemode == 3} { putserv "kick $chan $nick :please dont set topics containing bad words" }
if {$revengemode == 4} { chattr $hand -fhjmnoptx }
if {$revengemode == 5} { chattr $hand -fhjmnoptx ; chattr $hand +dk }
set topicfile "topic.$chan"
if {[file exists $topicfile]} { 
set dateichen [open "$topicfile" r]
set temp [gets $dateichen]
set temp [split $temp]
close $dateichen
set day [lindex $temp 5]
set newtopic [join [lrange $temp 9 [llength $temp]]]
if {$day == "" } { set newtopic [join [lrange $temp 10 [llength $temp]]]}
putserv "topic $chan :$newtopic"
return 0
}}}
if {($nick != "*") && ($uhost != "*") && ($topic != "") && ($nick != $botnick)} {
set topicfile topic.$chan
set historyfile history.$chan
set tempfile temp.$chan
if {[file exists $topicfile]} { 
set dateichen [open "$topicfile" r]
set oldtopic [gets $dateichen]
close $dateichen
} else {set oldtopic ""}
set dateichen2 [open "$tempfile" w+]
puts $dateichen2 "$oldtopic"
close $dateichen2
if {[file exists $historyfile]} { 
set dateichen3 [open "$historyfile" r]
} else { 
set dateichen3 [open "$historyfile" w+]
close $dateichen3
set dateichen3 [open "$historyfile" r]
}
set dateichen4 [open "$tempfile" a]
while {![eof $dateichen3]} {
set zeile [gets $dateichen3]
if {($zeile != "") && ($zeile != " ") } {puts $dateichen4 "$zeile"}
}
close $dateichen3
close $dateichen4
set dateichen5 [open "$historyfile" w]
set dateichen6 [open "$tempfile" r]
while {![eof $dateichen6]} {
set zeile [gets $dateichen6]
if {$zeile != "" && ($zeile != " ")} { puts $dateichen5 "$zeile"}
}
close $dateichen5
close $dateichen6
set time [ctime [unixtime]]
set dateichen7 [open "$topicfile" w]
puts $dateichen7 "$nick $chan $uhost $time $hand $topic"
close $dateichen7
if {($htmloutput == "yes") && (([lsearch -exact [string tolower $htmlchans] [string tolower $chan]] != -1) || ($htmlchans == ""))} {
dohtml $chan $htmlstyle
}}
}}


proc pub_topic {nick uhost hand chan arg} {
global topicchans
if {([lsearch -exact [string tolower $topicchans] [string tolower $chan]] != -1) || ($topicchans == "")} {
if { $arg == ""} {set topicfile topic.$chan }
if { $arg != ""} {set topicfile topic.$arg }
if {[file exists $topicfile]} { 
set dateichen [open "$topicfile" r]
set temp [gets $dateichen]
set temp [split $temp]
close $dateichen
set nickname [lindex $temp 0]
set channel [lindex $temp 1]
set hostmask [lindex $temp 2]
set weekday [lindex $temp 3]
set month [lindex $temp 4]
set day [lindex $temp 5]
set daytime [lindex $temp 6]
set year [lindex $temp 7]
set topic [join [lrange $temp 9 [llength $temp]]]
if {($day == "" )} {
set day [lindex $temp 6]
set daytime [lindex $temp 7]
set year [lindex $temp 8]
set handle [lindex $temp 9]
set topic [join [lrange $temp 10 [llength $temp]]]
}
putserv "privmsg $chan :the topic '$topic' was set by $nickname ($hostmask) at $daytime $weekday $day $month $year"
}}}


proc msg_topic {nick uhost hand arg} {
global topictrigger
if { $arg == ""} {
 putserv "privmsg $nick :usage $topictrigger <channel>"
 return 0}
if { $arg != ""} {
set topicfile topic.$arg
if {[file exists $topicfile]} { 
set dateichen [open "$topicfile" r]
set temp [gets $dateichen]
set temp [split $temp]
close $dateichen
set nickname [lindex $temp 0]
set channel [lindex $temp 1]
set hostmask [lindex $temp 2]
set weekday [lindex $temp 3]
set month [lindex $temp 4]
set day [lindex $temp 5]
set daytime [lindex $temp 6]
set year [lindex $temp 7]
set topic [join [lrange $temp 9 [llength $temp]]]
if {($day == "" )} {
set day [lindex $temp 6]
set daytime [lindex $temp 7]
set year [lindex $temp 8]
set handle [lindex $temp 9]
set topic [join [lrange $temp 10 [llength $temp]]]
}
putserv "privmsg $nick :the topic '$topic' was set by $nickname ($hostmask) at $daytime $weekday $day $month $year"}
}}


proc topicleer { nick uhost hand chan topic } {
if {$topic == ""} {
set topicfile "topic.$chan"
if {[file exists $topicfile]} { 
set dateichen [open "$topicfile" r]
set temp [gets $dateichen]
set temp [split $temp]
close $dateichen
set day [lindex $temp 5]
set newtopic [join [lrange $temp 9 [llength $temp]]]
if {$day == "" } { set newtopic [join [lrange $temp 10 [llength $temp]]]}
putserv "topic $chan :$newtopic"
}}}

proc pub_settopic {nick uhost hand chan arg} {
global topicchans settopic
if {$settopic == "yes" } {
if {($arg != "") && (([isop $nick $chan] == 1) || ([isvoice $nick $chan] == 1))} {
if {([lsearch -exact [string tolower $topicchans] [string tolower $chan]] != -1) || ($topicchans == "")} {
putserv "topic $chan :$arg"
savetopic $nick $uhost $hand $chan $arg
}}}}

proc msg_settopic {nick uhost hand arg} {
global settopictrigger settopic topicchans
if {$settopic == "yes" } {
if {([lindex $arg 0] == "") || ([lindex $arg 1] == "")} {
putserv "privmsg $nick :usage: $settopictrigger <channel> <topic>"
return 0 }
if {($arg != "") && (([isop $nick [lindex $arg 0]] == 1) || ([isvoice $nick [lindex $arg 0]] == 1))} {
if {([lsearch -exact [string tolower $topicchans] [string tolower [lindex $arg 0]]] != -1) || ($topicchans == "")} {
putserv "topic [lindex $arg 0] :[join [lrange $arg 1 [llength $arg]]]"
savetopic $nick $uhost $hand [lindex $arg 0] [join [lrange $arg 1 [llength $arg]]]
}}}}


putlog "*** topicmaster.tcl $topicversion by domsen succesfully loaded"

#[EOF]